// Variable para manejar el datatable
var oTable = null;
var lista = [];

// Codigo de Ejecucion principal
$(document).ready(function(){
  // Cargar Variable jsonTipoCdp
  // ==============================================================
  var jsonTipoCdp = (function () {
                        var json = null;
                        $.ajax({
                            async: false,
                            global: false,
                            url: '/a/js/swfacturador/TipoComprobante.json',
                            dataType:'JSON',
                            success: function (data) {
                                json = data.TipoComprobante;
                            }
                        });
                        return json;
                    })();
  // Cargar Variable jsonSituacion
  // ==============================================================
  var jsonSituacion = (function () {
                        var json = null;
                        $.ajax({
                            async: false,
                            global: false,
                            url: '/a/js/swfacturador/Situacion.json',
                            dataType:'JSON',
                            success: function (data) {
                                json = data.ListaSituacion;
                            }
                        });
                        return json;
                    })();
 
  // Configuracion base del datatable
//==============================================================
  var config =   {
		  				"responsive": true,
                       "bProcessing": false,
                    	 "bFilter": true,
                    	 "bAutoWidth": false,
                       "aaSorting": [],
                       "bLengthChange": false,  
                         "aaData": lista,
                         "oLanguage": {
                             	"sProcessing":     "Procesando...",
                        	    "sLengthMenu":     "Mostrar _MENU_ registros",
                        	    "sSearch":  		"Búsqueda: ",
                        	    "sZeroRecords":    "No se encontraron resultados",
                        	    "sEmptyTable":     "No se encontro comprobantes de pago registrados",
                        	    "sInfo":           "Mostrando registros del _START_ al _END_ de un total de _TOTAL_ registros",
                        	    "sInfoEmpty":      "Mostrando registros del 0 al 0 de un total de 0 registros",
                        	    "sInfoThousands":  ",",
                        	    "sLoadingRecords": "Cargando...",
                        	    "oPaginate": {
                        	        "sFirst":    "Primero",
                        	        "sLast":     "�ltimo",
                        	        "sNext":     "Siguiente",
                        	        "sPrevious": "Anterior"
                        	    }
                         },
                         "columnDefs": [
                                        { "width": "5%", "targets": 0 },
                                        { "width": "5%", "targets": 1 },
                                        { "width": "10%", "targets": 2 },
                                        { "width": "10%", "targets": 3 },
                                        { "width": "0%", "targets": 4 },
                                        { "width": "10%", "targets": 5 },
                                        { "width": "15%", "targets": 6 },
                                        { "width": "20%", "targets": 7 },
                                        { "width": "25%", "targets": 8 }
                                      ],
                         "aoColumns": [
                             { "mRender": function (data, type, row) {
                                  return "";},sDefaultContent: "-", "bSortable": true },
                             { "mData": "num_ruc", sDefaultContent: "-", "bSortable": false },     
                             { "mRender": function (data, type, row) {
                                 var nomTipoCdp = null;
                                 $.each(jsonTipoCdp, function(key, val){
                                      if(val.id == row.tip_docu){
                                        nomTipoCdp = val.nombre;
                                        return false;
                                      }
                                  });
                                  
                                  return nomTipoCdp;
                                  
                                 }, sDefaultContent: "-", "bSortable": true },
                             { "mData": "num_docu", sDefaultContent: "-", "bSortable": true },
                             { "mData": "fec_carg", sDefaultContent: "-", "bSortable": true },
                             { "mData": "fec_gene", sDefaultContent: "-", "bSortable": true },
                             { "mData": "fec_envi", sDefaultContent: "-", "bSortable": true },
                             { "mRender": function (data, type, row) {
                                 var nomSituacion = null;
                                 $.each(jsonSituacion, function(key, val){
                                      if(val.id == row.ind_situ){
                                        nomSituacion = val.nombre;
                                        return false;
                                      }
                                  });
                                  
                                  return nomSituacion;
                                  
                                 }, sDefaultContent: "-", "bSortable": true },
                             { "mData": "des_obse", sDefaultContent: "-", "bSortable": true }     
                         ],
                         "fnRowCallback": function (nRow, aData, iDisplayIndex, iDisplayIndexFull) {
                                       var index = iDisplayIndexFull+1;
                                       $('td:eq(0)',nRow).html(index);
                                       return nRow;
                                    },
                         "drawCallback": function ( settings ) {
                                        var api = this.api();
                                        var rows = api.rows( {page:'current'} ).nodes();
                                        var last=null;
                             
                                        api.column(4, {page:'current'} ).data().each( function ( group, i ) {
                                            if ( last !== group ) {
                                                $(rows).eq( i ).before(
                                                    '<tr class="group" id="idGrupo"><td colspan="9" align="left"><B>Fecha de Carga: '+group+'</B></td></tr>'
                                                );
                             
                                                last = group;
                                            }
                                        });
                                        }
                    	};
  
    // Aplicando configuracion
  	//==============================================================
    oTable = $("#tDetail").dataTable(config);
    
    // configurando el comportamiento de las filas de la pantalla
    // ==============================================================
    $("#tDetail tbody").on( "click", "tr", function () {
        
        var id = this.id;
        
        if(id!="idGrupo"){
        
          if ( $(this).hasClass("selected") ) {
              $(this).removeClass("selected");
              $("#hddNumRuc").val("");  
              $("#hddTipDoc").val("");
              $("#hddNumDoc").val("");
          } else {
              oTable.$("tr.selected").removeClass("selected");
              $(this).addClass("selected");
              var iPos = oTable.fnGetPosition( this );
              if(iPos!=null){
                  //couple of example on what can be done with the clicked row...
                  var aData = oTable.fnGetData( iPos );//get data of the clicked row
                  $("#hddNumRuc").val(aData.num_ruc);  
                  $("#hddTipDoc").val(aData.tip_docu);
                  $("#hddNumDoc").val(aData.num_docu);
                  $("#hddNomArc").val(aData.nom_arch);
              }else{
                  $("#hddNumRuc").val("");  
                  $("#hddTipDoc").val("");
                  $("#hddNumDoc").val("");
                  $("#hddNomArc").val("");
              }
          }
        }
               
        
        
    } );
    
    
    // Configurando Eventos
    //==============================================================
    $( window ).load(function() {
    	cargarPantalla();
   	});
    
    
    // Configurando Temporizador de Refresh de la Pantalla
    //==============================================================
    setInterval(refrescarTabla, 25000); //25000
        
    // Configurando Hora de Ejecución
    //==============================================================
    $("label[for='text-mensaje-hora']").text("");
    
    // Configurando Botones del menú principal
    //==============================================================
    $("#btnRefrescar").bind("click",function(){
    	refrescarTabla();
    });
      
	$("#btnLimpiar").bind("click",function(){
		limpiarBandeja();
	}); 
	
	$("#btnGenerar").bind("click",function(){
		generarComprobante();
    });
	    
    $("#btnEnviar").bind("click",function(){
    	enviarComprobante();
    });
    
    $("#cmbFuncionamiento").bind("change",function(){
	    if(this.value == "01"){
	      $("#minutos").attr("style", "visibility: visible");
	      $("#minutos").css("display", "block");
	      
	      $("#horaEjecucionAuto").attr("style", "visibility: hidden");
	      $("#horaEjecucionAuto").css("display", "none");
	      
	     
	      $("#btnRefrescar").hide();
	      $("#btnVisorCdp").hide();
	      
	    }else{
	      $("#minutos").attr("style", "visibility: hidden");
	      $("#minutos").css("display", "none");
	      
	      $("#horaEjecucionAuto").attr("style", "visibility: visible");
	      $("#horaEjecucionAuto").css("display", "block");
	      
	     
	      $("#btnRefrescar").show();
	      $("#btnVisorCdp").show();
	      
	    }
	    $("#cmbTiempoGenera").val("");
	    $("#cmbTiempoEnviar").val("");
	  });
    
    
   // Configurando Botones de la Ventana Acerca de 
   //==============================================================
    $("#btnCerrarAcerca").bind("click",function(){
	     $("#ventanaAcercaDe").modal("hide");
	   });
    
   
    // Configurando Botones Limpiar Documentos de Bandeja 
    //==============================================================
    $("#btnConformeLimpiar").bind("click",function(){
           var validar = {"rutaCertificado": ""};
           var limpiarBandejaFactu = $.ajax({
                                       type: "POST",
                             		    	contentType: "application/json",
                             		      url: "api/EliminarBandeja.htm",  
                                       data: JSON.stringify(validar),	
                             		      dataType: "json",
                             		      async: false
                                     });

           limpiarBandejaFactu.success(function(resultado) {
                   if (resultado.validacion == "EXITO"){
                      oTable.fnClearTable();
                      $("label[for = lbError]").text("");
                      $("#ventanaLimpiar").modal("hide");
                   }else{
                     $("label[for = lbError]").text(resultado.validacion);
                   } 
                   
           });                
         
           limpiarBandejaFactu.error(function(xmlHttpRequest, textStatus, errorThrown){
             if (xmlHttpRequest.readyState == 4) {
                 if (xmlHttpRequest.status != 200) {
                   $("label[for = lbError]").text("Error en el Sistema, por favor comunicarse con soporte.");;
                 }
               }
           });                                  
                                     
                                     
      });
    
    $("#btnNoConformeLimpiar").bind("click",function(){
        $("#ventanaLimpiar").modal("hide");
        $("label[for = lbError]").text("");     
    });
    
    
    // Configurando Botones Carga de Parametros 
    //==============================================================
    $("#btnAceptar").bind("click",function(){
        var txtNumeroRuc = $("#txtNumeroRuc").val();
        var txtUsuarioSol = $("#txtUsuarioSol").val();
        var txtClaveSol = $("#txtClaveSol").val();
        var cmbFuncion = $("#cmbFuncionamiento").val();
        var razonSocial = $("#txtRazonSocial").val();
        var cmbTiempoGenera = $("#cmbTiempoGenera").val();
        var cmbTiempoEnvia = $("#cmbTiempoEnviar").val();
        var txtRutaSolucion = $("#txtRutaSolucion").val();
        var txtUsuarioSolPrincipal = $("#txtUsuarioSolPrincipal").val();
        var txtClaveSolPrincipal = $("#txtClaveSolPrincipal").val();
        var txtClient_id = $("#txtClient_id").val();
        var txtClient_secret = $("#txtClient_secret").val();
                    
        var validar = {"txtNumeroRuc": txtNumeroRuc, "txtUsuarioSol": txtUsuarioSol, "txtClaveSol": txtClaveSol, "cmbFuncionamiento": cmbFuncion, "txtRazonSocial": razonSocial, "cmbTiempoGenera": cmbTiempoGenera, "cmbTiempoEnvia": cmbTiempoEnvia, "txtRutaSolucion" : txtRutaSolucion, "txtUsuarioSolPrincipal": txtUsuarioSolPrincipal, "txtClaveSolPrincipal": txtClaveSolPrincipal, "txtClient_id" : txtClient_id, "txtClient_secret": txtClient_secret};
        
        var grabarParametros = $.ajax({
                                    type: "POST",
                          		    	contentType: "application/json",
                          		      url: "api/GrabarParametro.htm",  
                          		      data: JSON.stringify(validar),	
                          		      dataType: "json",
                          		      async: false
                                  });
                    
              
        grabarParametros.success(function(resultado) {
                if (resultado.validacion == "EXITO"){
                  if((cmbFuncion == "01")){
                      $("#piePagina").attr("style", "visibility: hidden");
                      $("#piePagina").css("display", "none");
                      
                      $("#horaEjecucionAuto").attr("style", "visibility: visible");
                      $("#horaEjecucionAuto").css("display", "block");
                      
                      $("#btnRefrescar").hide();
                      $("#btnVisorCdp").hide();
                      
                  }else{
                      $("#piePagina").attr("style", "visibility: visible");
                      $("#piePagina").css("display", "block");
                      
                      $("#horaEjecucionAuto").attr("style", "visibility: hidden");
                      $("#horaEjecucionAuto").css("display", "none");
                      
                      $("#btnRefrescar").show();
                      $("#btnVisorCdp").show();
                      
                  }    
                  
                  $("#ventanaConfiguracion").modal("hide");
                  $("label[for = lbError]").text("");
                }else{
                  $("label[for = lbError]").text(resultado.validacion);
                } 
                
        });                
    
        grabarParametros.error(function(xmlHttpRequest, textStatus, errorThrown){
          if (xmlHttpRequest.readyState == 4) {
              if (xmlHttpRequest.status != 200) {
                $("label[for = lbError]").text("Error en el Sistema, por favor comunicarse con soporte.");;
              }
            }
        });
      });
    
    $("#btnCancelar").bind("click",function(){
        $("#ventanaConfiguracion").modal("hide");
        $("label[for = lbError]").text("");
       });
    
    
    // Configurando Botones Carga de Otros Parametros 
    //==============================================================
    
    $("#btnAceptarOtro").bind("click",function(){
        var txtNombreComercial = $("#txtNombreComercial").val();
        var txtUbigeo = $("#txtUbigeo").val();
        var txtDireccion = $("#txtDireccion").val();
        var txtDepartamento = $("#txtDepartamento").val();
        var txtProvincia = $("#txtProvincia").val();
        var txtDistrito = $("#txtDistrito").val();
        var txtUrbanizacion = $("#txtUrbanizacion").val();
        
                                
        var validar = {"txtNombreComercial": txtNombreComercial,"txtUbigeo": txtUbigeo,"txtDireccion": txtDireccion,"txtDepartamento": txtDepartamento,
                       "txtProvincia": txtProvincia, "txtDistrito": txtDistrito, "txtUrbanizacion": txtUrbanizacion};
        
        var grabarOtrosParametros = $.ajax({
                                              type: "POST",
                                    		    	contentType: "application/json",
                                    		      url: "api/GrabarOtrosParametros.htm",  
                                    		      data: JSON.stringify(validar),	
                                    		      dataType: "json",
                                    		      async: false
                                            });
                    
              
        grabarOtrosParametros.success(function(resultado) {
                if (resultado.validacion == "EXITO"){
                   $("#ventanaOtrosConfiguracion").modal("hide");
                   $("label[for = lbError]").text("");
                }else{
                  $("label[for = lbError]").text(resultado.validacion);
                } 
                
        });
    
        grabarOtrosParametros.error(function(xmlHttpRequest, textStatus, errorThrown){
          if (xmlHttpRequest.readyState == 4) {
              if (xmlHttpRequest.status != 200) {
                $("label[for = lbError]").text("Error en el Sistema, por favor comunicarse con soporte.");;
              }
            }
        });
      });
      
     $("#btnCancelarOtro").bind("click",function(){
       $("#ventanaOtrosConfiguracion").modal("hide");
       $("label[for = lbError]").text("");
     });
     
     
     // Configurando Botones Carga de Certificado 
     //==============================================================
     
     $("#btnCancelarCertificado").bind("click",function(){
         $("#ventanaImportarCertificado").modal("hide");
         $("label[for = lbError]").text("");
         $("#cmbRutaCertificado").html("");
         $("#cmbRutaCertificado").append("<option value=\"\">Seleccione Certificado</option>"); 
      });
     
     $("#btnImportarCertificado").bind("click",function(){
         var rutaCertificado = $("#cmbRutaCertificado").val();
         var passPrivateKey  = $("#txtPassPrivateKey").val();
         var validar = {"nombreCertificado": rutaCertificado,"passPrivateKey" : passPrivateKey};
                  
         var importarCertificado = $.ajax({
                                     type: "POST",
                           		    	contentType: "application/json",
                           		      url: "api/ImportarCertificado.htm",  
                           		      data: JSON.stringify(validar),	
                           		      dataType: "json",
                           		      async: false
                                   });
                     
               
         importarCertificado.success(function(resultado) {
                 if (resultado.validacion == "EXITO"){
                    $("label[for = lbError]").text("");
                    $("#ventanaImportarCertificado").modal("hide");
                    $("#cmbRutaCertificado").html("");
                    $("#cmbRutaCertificado").append("<option value=\"\">Seleccione Certificado</option>");
                    $("#txtPassPrivateKey").val("");
                 }else{
                   $("label[for = lbError]").text(resultado.validacion);
                 } 
                 
         });                
     
         importarCertificado.error(function(xmlHttpRequest, textStatus, errorThrown){
           if (xmlHttpRequest.readyState == 4) {
               if (xmlHttpRequest.status != 200) {
                 $("label[for = lbError]").text("Error en el Sistema, por favor comunicarse con soporte.");;
               }
             }
         });
  
     
     });
     
     $("#cmbRutaCertificado").bind("change",function(){
         $("#txtPassPrivateKey").val("");
       });
     
     // Configurando Botones Actualizar Versión 
     //==============================================================
       $("#btnNoConformeActualizar").bind("click",function(){
         $("#ventanaActualizador").modal("hide");
       });
       
       $("#btnConformeActualizar").bind("click",function(){
          var validar = {"txtSecuencia":"000"};
  	      var refrescarLista = $.ajax({
  	                                type: "POST",
  	                      		    	contentType: "application/json; charset=utf-8",
  	                      		      url: "api/ActualizarFacturador.htm",  
  	                      		      data: JSON.stringify(validar),	
  	                      		      dataType: "json",
  	                      		      async: false
  	                              });
  	    
	  	    refrescarLista.success(function(resultado){	
	  	    	if(resultado.proceso != "ERROR"){
	  	    		$("#ventanaActualizador").modal("hide");
	  	    		$("#mensaje").text(resultado.mensaje);
	  	    		$("#ventanaInformacion").modal({ keyboard: false });
	  	    		$("#ventanaInformacion").modal("show");
	  	    	}else{
	  	    		$("#ventanaActualizador").modal("hide");
	  	    		$("#mensajeError").text(resultado.mensaje);
	  	    		$("#ventanaExcepciones").modal({ keyboard: false });
	  	    		$("#ventanaExcepciones").modal("show");
	  	    	}
	  	    });
       });  
       
       // Configurando Boton Mensaje de Excepciones 
       //==============================================================
       $("#btnCerrarExcepciones").bind("click",function(){
	     $("#ventanaExcepciones").modal("hide");
	   });
       
       // Configurando Boton Mensaje de Informacion 
       //==============================================================
       $("#btnCerrarInformacion").bind("click",function(){
	     $("#ventanaInformacion").modal("hide");
	   });
       
       // Mostrar XML 
       //==============================================================
       $("#btnVisorCdp").bind("click",function(){
    	      mostrarArchivoXml();
    	    });
    	   
	   $("#btnCerrarVisor").bind("click",function(){
	     $("#ventanaVisorXml").modal("hide");
	   });
    	   
    
    
});
    
// Configurar funcionalidades    
//==============================================================

	/*Cargar Pantalla*/
	function cargarPantalla(){
	    var validar = {"txtSecuencia":"000"};
	    var refrescarLista = $.ajax({
	                                type: "POST",
	                      		    	contentType: "application/json; charset=utf-8",
	                      		      url: "api/CargarPantalla.htm",  
	                      		      data: JSON.stringify(validar),	
	                      		      dataType: "json",
	                      		      async: false
	                              });
	    
	    refrescarLista.success(function(resultado) 
	    {	
	    	if (resultado.validacion == "EXITO"){
	        	
	    		var nombre = resultado.razonSocial; 
	    		var ruc = resultado.numRuc;
	    		var version = resultado.version;
	    		var tipoFuncionalidad = resultado.tipoFuncion; 

	    		$("label[for='text-datosContribuyente']").text("Contribuyente: " + ruc + " - " + nombre);
	    		$("#text-pie-version").text("Versión: " + version);
	    		
	    		if (tipoFuncionalidad == "01"){
	    		      $("#piePagina").attr("style", "visibility: hidden");
	    		      $("#piePagina").css("display", "none");

	    		      $("#horaEjecucionAuto").attr("style", "visibility: visible");
	    		      $("#horaEjecucionAuto").css("display", "block");
	    		      /*Hacer Visibles Botones del Navegador del App*/
	    		      
	    		      $("#btnRefrescar").hide();
	    		      $("#btnVisorCdp").hide();
	    		          
	    		}else{
	    		      $("#piePagina").attr("style", "visibility: visible");
	    		      $("#piePagina").css("display", "block");
	    		      
	    		      $("#horaEjecucionAuto").attr("style", "visibility: hidden");
	    		      $("#horaEjecucionAuto").css("display", "none");
	    		    
	    		      /*Hacer Visibles Botones del Navegador del App*/
	    		      $("#btnRefrescar").show();
	    		      $("#btnVisorCdp").show();
	    		      
	    		} 
	    		
	    		/*En la caso llegue mensaje de Error*/
	    		mensajeError(resultado.mensaje);
	    		
		    }
	    });
	}; 

	
	/*Refrescar Pantalla*/
	function refrescarTabla(){
	    var validar = {"txtSecuencia":"000"};
	    var refrescarLista = $.ajax({
	                                type: "POST",
	                      		    	contentType: "application/json; charset=utf-8",
	                      		      url: "api/ActualizarPantalla.htm",  
	                      		      data: JSON.stringify(validar),	
	                      		      dataType: "json",
	                      		      async: false
	                              });
	    
	    refrescarLista.success(function(resultado) 
	    {	
	    	if (resultado.validacion == "EXITO"){
	    		if (resultado.listaBandejaFacturador!=null&&resultado.listaBandejaFacturador.length > 0){
	    		   	oTable.fnClearTable();
        			oTable.fnAddData(resultado.listaBandejaFacturador);
	    		}
	    		
	    		if(resultado.fechaActual!=null){
	    			$("label[for='text-mensaje-hora']").text("Actualizado a: " + resultado.fechaActual);
	    		}else{
	    			$("label[for='text-mensaje-hora']").text("");
	    		}
	    			
		    }
	    	
	    	/*En la caso llegue mensaje de Error*/
    		mensajeError(resultado.mensaje);
	    });
	};
	
	
	/*Generar Comprobante*/
	function generarComprobante(){
		var numRuc = $("#hddNumRuc").val();
		var tipDoc = $("#hddTipDoc").val();
		var numDoc = $("#hddNumDoc").val();
	    var validar = {"num_ruc":numRuc,"tip_docu":tipDoc,"num_docu":numDoc };
	    var refrescarLista = $.ajax({
	                                type: "POST",
	                      		    	contentType: "application/json; charset=utf-8",
	                      		      url: "api/GenerarComprobante.htm",  
	                      		      data: JSON.stringify(validar),	
	                      		      dataType: "json",
	                      		      async: false
	                              });
	    
	    refrescarLista.success(function(resultado) 
	    {	
	    	if (resultado.validacion == "EXITO"){
	    		
	    		if (resultado.listaBandejaFacturador!=null&&resultado.listaBandejaFacturador.length > 0){
	    		   	oTable.fnClearTable();
        			oTable.fnAddData(resultado.listaBandejaFacturador);
	    		}
	    		
	    		/*En la caso llegue mensaje de Error*/
	    		mensajeError(resultado.mensaje);
		    }
	    });
	};
	
	
	/*Enviar Comprobante*/
	function enviarComprobante(){
		var numRuc = $("#hddNumRuc").val();
		var tipDoc = $("#hddTipDoc").val();
		var numDoc = $("#hddNumDoc").val();
	    var validar = {"num_ruc":numRuc,"tip_docu":tipDoc,"num_docu":numDoc };
	    var refrescarLista = $.ajax({
	                                type: "POST",
	                      		    	contentType: "application/json; charset=utf-8",
	                      		      url: "api/enviarXML.htm",  
	                      		      data: JSON.stringify(validar),	
	                      		      dataType: "json",
	                      		      async: false
	                              });
	    
	    refrescarLista.success(function(resultado) 
	    {	
	    	if (resultado.validacion == "EXITO"){
	    		
	    		if (resultado.listaBandejaFacturador!=null&&resultado.listaBandejaFacturador.length > 0){
	    		   	oTable.fnClearTable();
        			oTable.fnAddData(resultado.listaBandejaFacturador);
	    		}
	    		
	    		/*En la caso llegue mensaje de Error*/
	    		mensajeError(resultado.mensaje);
		    }
	    });
	}; 
    
    /*Ventana Acerca de */
	function acercaDe(){
		$("#ventanaAcercaDe").modal({ keyboard: false });
	    $("#ventanaAcercaDe").modal("show");
	};
	
	/*Ventana Limpiar Bandeja */
	function limpiarBandeja(){
	      $("#ventanaLimpiar").modal({ keyboard: false });
	      $("#ventanaLimpiar").modal("show");
	};
	
	/*Ventana de Configuración */
	function configurar(){

	      var validar = {"rutaCertificado": ""};
	      var datosParametro = $.ajax({
	                                  type: "POST",
	                        		    	contentType: "application/json",
	                        		      url: "api/CargarDatosParametro.htm",  
	                                  data: JSON.stringify(validar),	
	                        		      dataType: "json",
	                        		      async: false
	                                });
	                             
	      datosParametro.success(function(resultado) {
	              if (resultado.validacion == ""){
	                $("label[for = lbError]").text("");
	                $("#txtNumeroRuc").val(resultado.adjunto.numRuc);
	                $("#txtUsuarioSol").val(resultado.adjunto.usuarioSol);
	                $("#txtClaveSol").val(resultado.adjunto.claveSol);
	                $("#txtCertificado").val(resultado.adjunto.certificado);               
	                $("#cmbFuncionamiento").val(resultado.adjunto.funcionamiento);
	                $("#txtRazonSocial").val(resultado.adjunto.razonSocial);
	                $("#txtRutaSolucion").val(resultado.adjunto.rutaSolucion);
	                $("#txtUsuarioSolPrincipal").val(resultado.adjunto.usuarioSolPrincipal);
	                $("#txtClaveSolPrincipal").val(resultado.adjunto.claveSolPrincipal);
	                $("#txtClient_id").val(resultado.adjunto.client_id);
	                $("#txtClient_secret").val(resultado.adjunto.client_secret);
	                
	                if(resultado.adjunto.funcionamiento == "01"){
	                  $("#cmbTiempoGenera").val(resultado.adjunto.tiempoGenera);
	                  $("#cmbTiempoEnviar").val(resultado.adjunto.tiempoEnviar);
	                  $("#minutos").attr("style", "visibility: visible");
	                  $("#minutos").css("display", "block");
	                  $("#btnRefrescar").hide();
	                  $("#btnVisorCdp").hide();
	                }else{
	                  $("#cmbTiempoGenera").val("");
	                  $("#cmbTiempoEnviar").val("");
	                  $("#minutos").attr("style", "visibility: hidden");
	                  $("#minutos").css("display", "none");
	                  $("#btnRefrescar").show();
	                  $("#btnVisorCdp").show();
	                }
	                
	              }else{
	                $("label[for = lbError]").text(resultado.validacion);
	              } 
	      });                
	      
	      datosParametro.error(function(xmlHttpRequest, textStatus, errorThrown){
	        if (xmlHttpRequest.readyState == 4) {
	            if (xmlHttpRequest.status != 200) {
	              $("label[for = lbError]").text("Error en el Sistema, por favor comunicarse con soporte.");;
	            }
	          }
	      });
	      
	      $("#ventanaConfiguracion").modal({ keyboard: false });
	      $("#ventanaConfiguracion").modal("show");
	};
	
	/*Ventana de Configuración de otros parámetros */
	function configurarOtros(){

	      var validar = {"rutaCertificado": ""};
	      var datosOtrosParametro = $.ajax({
	                                  type: "POST",
	                        		    	contentType: "application/json",
	                        		      url: "api/CargarOtrosDatosParametros.htm",  
	                                  data: JSON.stringify(validar),	
	                        		      dataType: "json",
	                        		      async: false
	                                });
	                             
	      datosOtrosParametro.success(function(resultado) {
	              if (resultado.validacion == ""){
	                $("label[for = lbError]").text("");
	                $("#txtNombreComercial").val(resultado.adjunto.nombreComercial);
	                $("#txtUbigeo").val(resultado.adjunto.ubigeo);
	                $("#txtDireccion").val(resultado.adjunto.direccion);
	                $("#txtDepartamento").val(resultado.adjunto.departamento);               
	                $("#txtProvincia").val(resultado.adjunto.provincia);
	                $("#txtDistrito").val(resultado.adjunto.distrito);
	                $("#txtUrbanizacion").val(resultado.adjunto.urbanizacion);
	              }else{
	                $("label[for = lbError]").text(resultado.validacion);
	              } 
	      });                
	      
	      datosOtrosParametro.error(function(xmlHttpRequest, textStatus, errorThrown){
	        if (xmlHttpRequest.readyState == 4) {
	            if (xmlHttpRequest.status != 200) {
	              $("label[for = lbError]").text("Error en el Sistema, por favor comunicarse con soporte.");;
	            }
	          }
	      });

	      $("#ventanaOtrosConfiguracion").modal({ keyboard: false });
	      $("#ventanaOtrosConfiguracion").modal("show");
	};
	
	
	/* Importar Certificado al Facturador */
	
	function importarCertificado(){
		
		var validar = {"rutaCertificado": ""};
        var importarCertificado = $.ajax({
                                    type: "POST",
                          		    	contentType: "application/json",
                          		      url: "api/CargarListaCertificado.htm",  
                                    data: JSON.stringify(validar),	
                          		      dataType: "json",
                          		      async: false
                                  });
                    
              
        importarCertificado.success(function(resultado) {
                if (resultado.validacion == ""){
                  $("label[for = lbError]").text("");
                  $("#cmbRutaCertificado").html("");
                  $("#cmbRutaCertificado").append("<option value=\"\">Seleccione Certificado</option>"); 
                  $.each(resultado.adjunto, function(key, val){
                      $("#cmbRutaCertificado").append("<option value=\"" + val.id + "\">" + val.nombre + "</option>");  
                  });
                  $("#text-ruta-certificados").html(resultado.ruta);
                  $("#ventanaImportarCertificado").modal({ keyboard: false });
        	      $("#ventanaImportarCertificado").modal("show");
                }else{
                  $("label[for = lbError]").text(resultado.validacion);
                } 
        });                
    
        importarCertificado.error(function(xmlHttpRequest, textStatus, errorThrown){
          if (xmlHttpRequest.readyState == 4) {
              if (xmlHttpRequest.status != 200) {
                $("label[for = lbError]").text("Error en el Sistema, por favor comunicarse con soporte.");;
              }
            }
        });
	      
	};
	
	
	/* Actualizar Versión */
	function actualizarVersion(){
		  $("#ventanaActualizador").modal({ keyboard: false });
		  $("#ventanaActualizador").modal("show"); 
		};
		
		
		
	/* Mostrar Archivo XML */
	function mostrarArchivoXml(){
	      var nombreArchivo = $("#hddNomArc").val();
	      if (nombreArchivo){
	        var validar = {"nomArch": nombreArchivo};
	        var datosArchivo = $.ajax({
	                                    type: "POST",
	                          		    	contentType: "application/json",
	                          		      url: "api/MostrarXml.htm",  
	                                    data: JSON.stringify(validar),	
	                          		      dataType: "text",
	                          		      async: false
	                                  });
	                                  
	        datosArchivo.success(function(resultado) {
	                if (resultado != ""){
	                  $("#ventanaVisorXml").modal({ keyboard: false });
	                  $("#ventanaVisorXml").modal("show"); 
	                   $("label[for = lbMensaje]").text(resultado);     
	                } 
	        });
	        
	        datosArchivo.error(function(xmlHttpRequest, textStatus, errorThrown){
	          if (xmlHttpRequest.readyState == 4) {
	              if (xmlHttpRequest.status != 200) {
	                $("label[for = lbError]").text("Error en el Sistema, por favor comunicarse con soporte.");;
	              }
	            }
	        });
	      }
		};
		
		
	/* Funcion para mensajes de error */
	function mensajeError(mensaje){
		if(mensaje!=null&&mensaje!==""){
    		 $("#ventanaExcepciones").modal({ keyboard: false });
             $("#ventanaExcepciones").modal("show"); 
             $("#mensajeError").html(mensaje);
		/*}else{
            $("#ventanaExcepciones").modal("hide"); */
		}	
	};	
		
		
		
		
		